//		UnLHA-U v1.0
//		by: Jim Robbins
//		on: Wed Nov 27 5:00pm CST 1996
//		robbins@iastate.edu
//		http://www.public.iastate.edu/~robbins/be



//               Original Code by:
/* ++++++++++

   FILE:  make_tar.cpp
   REVS:  $Revision: 1.1 $
   NAME:  steve
   DATE:  Fri Jan 26 16:09:34 PST 1996

   Copyright (c) 1996 by Be Incorporated.  All Rights Reserved.

+++++ */

#include <Directory.h>
#include <Window.h>
#include <Rect.h>
#include <View.h>
#include <File.h>
#include <Alert.h>
#include <AppDefs.h>
#include <Message.h>
#include <Errors.h>

#include <Debug.h>

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


extern char** environ;

#define DEFAULT_PARAMS 2

class TStatusView : public BView {
public:
					TStatusView(BRect);
virtual void		Draw(BRect);
};

class TStatusWindow : public BWindow {
public:
					TStatusWindow();
};

#pragma export on
void process_refs(record_ref dir_ref, BMessage* msg, void*);
#pragma export reset

void process_refs(record_ref dir_ref, BMessage* msg, void*)
{

	BAlert*			alert;
	char**			eargv;
	char**			newarg;
	char			name[B_FILE_NAME_LENGTH];
	TStatusWindow*	wind;
	ulong			type;
	record_ref		ref;
	long			result;
	thread_info		info;
	long			count;
	long			i;
	BFile			file;
	BStore*			store_ptr;
	BDirectory		dir;
	char			path[1000];
	thread_id		tid;

	// this add-on requires a selection
	msg->GetInfo("refs", &type, &count);
	if (count == 0) {
		alert = new BAlert("", "You must select an archive if you want to UnLHA anything.", "OK");
		alert->Go();
		return;
	}

	dir.SetRef(dir_ref);
	if (dir.Error() != B_NO_ERROR) {
		alert = new BAlert("", "You must extract archives from files.", "OK");
		alert->Go();
		return;
	}

	dir.GetPath(path, 1000);
	chdir(path);


	// create argv style buffer to pass to tar tool
	// need string for each entry, default params, and null entry at end
	eargv = (char**)malloc((count + DEFAULT_PARAMS + 1) * (sizeof(char*)));
	newarg = (char**)malloc(4 * sizeof(char*));


	for (i = 0; i < count; i++) {
		ref = msg->FindRef("refs", i);
		if (does_ref_conform(ref, "File")) {
			file.SetRef(ref);
			store_ptr = &file;
		} else {
			dir.SetRef(ref);
			store_ptr = &dir;
		}
			
		if (store_ptr->Error() != B_NO_ERROR) {
			alert = new BAlert("", "Sorry, you can't extract items that only exist in the database.", "OK");
			alert->Go();
			count = i;
			goto exit;
		}
			
		store_ptr->GetName(name);
		eargv[i + DEFAULT_PARAMS] = (char*)malloc(strlen(name) + 1);
		strcpy(eargv[i + DEFAULT_PARAMS], name);
	}

	// launch lha tool with argv buffer
	newarg[0] = "/boot/bin/lha";
	newarg[1] = "xf";
	newarg[2] = (char*)malloc(65 * sizeof(char));
	newarg[3] = 0;
	wind = new TStatusWindow();
		for (i = 0; i < count; i++) {
		strcpy(newarg[2],eargv[i + DEFAULT_PARAMS]);
		wind->SetTitle(newarg[2]);
		tid = load_posix(newarg[0], newarg, environ);
		if (tid > 0) {
			resume_thread(tid);
			wait_for_thread(tid, &result);
		} else {
			alert = new BAlert("", "Sorry, could not find the required /boot/bin/lha program.", "OK");
			alert->Go();
		}
	}
	wind->Close();
exit:
	for (i = 0; i < count; i++)
		free(eargv[i + DEFAULT_PARAMS]);
	free(eargv);
	free(newarg[2]);
	free(newarg);
}

// ---------------------------------------------------------------

TStatusView::TStatusView(BRect r)
		    :BView(r, "", B_FOLLOW_NONE, B_WILL_DRAW | B_PULSE_NEEDED)
{
}

// ---------------------------------------------------------------

void TStatusView::Draw(BRect)
{
	SetFontName("Times New Roman");
	SetFontSize(18);
	MovePenTo(10, 20);
	DrawString("Extracting LHA archive(s)...");

}

// ---------------------------------------------------------------


TStatusWindow::TStatusWindow()
			  :BWindow(BRect(100, 120, 330, 150), "Archive status", B_TITLED_WINDOW,
					   B_NOT_CLOSABLE | B_NOT_RESIZABLE)
{
	BRect	status_wind_rect(100, 120, 330, 150);

	status_wind_rect.OffsetTo(B_ORIGIN);
	AddChild(new TStatusView(status_wind_rect));
	Show();
}
